(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("node-discover"), require("child_process"), require("fs-extra"), require("http"), require("http-proxy"), require("node-git-server"));
	else if(typeof define === 'function' && define.amd)
		define("starbucket", ["node-discover", "child_process", "fs-extra", "http", "http-proxy", "node-git-server"], factory);
	else if(typeof exports === 'object')
		exports["starbucket"] = factory(require("node-discover"), require("child_process"), require("fs-extra"), require("http"), require("http-proxy"), require("node-git-server"));
	else
		root["starbucket"] = factory(root["node-discover"], root["child_process"], root["fs-extra"], root["http"], root["http-proxy"], root["node-git-server"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_3__, __WEBPACK_EXTERNAL_MODULE_5__, __WEBPACK_EXTERNAL_MODULE_6__, __WEBPACK_EXTERNAL_MODULE_7__, __WEBPACK_EXTERNAL_MODULE_8__, __WEBPACK_EXTERNAL_MODULE_9__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 4);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ConsoleLogger = function () {
  function ConsoleLogger() {
    _classCallCheck(this, ConsoleLogger);
  }

  _createClass(ConsoleLogger, [{
    key: 'log',
    value: function log(level, msg) {
      var timeStamp = '[' + new Date().toISOString() + ']';
      console.log(timeStamp + ' ' + this.pad(4, level, ' ') + ' - ' + msg);
    }

    // private

  }, {
    key: 'pad',
    value: function pad(width, string, padding) {
      return width <= string.length ? string : this.pad(width, padding + string, padding);
    }
  }]);

  return ConsoleLogger;
}();

module.exports = ConsoleLogger;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var http = __webpack_require__(7);
var spawn = __webpack_require__(5).spawn;
var fs = __webpack_require__(6);
var nodeGitServer = __webpack_require__(9);

var GitServer = function () {
  function GitServer(attrs) {
    _classCallCheck(this, GitServer);

    this.port = attrs.port;
    this.storagePath = attrs.storagePath;
    this.logger = attrs.logger;
    var dataReceivedCallback = attrs.dataReceivedCallback;

    this.server = this.createServer(this.storagePath, dataReceivedCallback);
  }

  _createClass(GitServer, [{
    key: 'start',
    value: function start() {
      var _this = this;

      return new Promise(function (resolve) {
        _this.server.listen(_this.port, function () {
          _this.logger.log('git', 'git server started at http://localhost:' + _this.port);
          resolve();
        });
      });
    }
  }, {
    key: 'stop',
    value: function stop() {
      var _this2 = this;

      return new Promise(function (resolve) {
        _this2.server.close();
        _this2.logger.log('info', 'git server stopped');
        resolve();
      });
    }
  }, {
    key: 'mirrorRepo',
    value: function mirrorRepo(remoteServerUrl, repoName) {
      var _this3 = this;

      var localRepoPath = this.storagePath + '/' + repoName + '.git/';
      var remoteRepoUrl = remoteServerUrl + '/' + repoName;

      return this.initializeRepoIfneeded(localRepoPath).then(function () {
        _this3.sync(localRepoPath, remoteRepoUrl);
      });
    }
  }, {
    key: 'clearTmp',
    value: function clearTmp() {
      var _this4 = this;

      this.logger.log('git', 'clearing temp files: ' + this.storagePath);

      return new Promise(function (resolve, reject) {
        fs.remove(_this4.storagePath, function (err) {
          err ? reject(err) : resolve();
        });
      });
    }

    // private

  }, {
    key: 'createServer',
    value: function createServer(repoStoragePath, dataReceivedCallback) {
      var _this5 = this;

      var gitOperationHandler = nodeGitServer(repoStoragePath);

      gitOperationHandler.on('push', function (push) {
        _this5.logger.log('git', 'push received. Repo: ' + push.repo + ', branch: ' + push.branch + ' (' + push.commit + ')');
        push.accept();
        dataReceivedCallback(push.repo);
      });

      return http.createServer(function (req, res) {
        gitOperationHandler.handle(req, res);
      });
    }
  }, {
    key: 'initializeRepoIfneeded',
    value: function initializeRepoIfneeded(localRepoPath) {
      return new Promise(function (resolve) {
        var proc = spawn('git', ['init', '--bare', localRepoPath]);
        proc.on('close', function () {
          resolve();
        });
      });
    }
  }, {
    key: 'sync',
    value: function sync(localRepoPath, remoteRepoUrl) {
      this.logger.log('git', 'mirroring ' + remoteRepoUrl + ' -> ' + localRepoPath);

      spawn('git', ['--git-dir=' + localRepoPath, 'fetch', remoteRepoUrl, '+refs/heads/*:refs/heads/*']);
    }
  }]);

  return GitServer;
}();

module.exports = GitServer;

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var httpProxy = __webpack_require__(8);

var ProxyServer = function () {
  function ProxyServer(attrs) {
    _classCallCheck(this, ProxyServer);

    this.port = attrs.port;
    this.logger = attrs.logger;
    this.targetUrl = undefined;
    this.server = null;
  }

  _createClass(ProxyServer, [{
    key: 'getTargetUrl',
    value: function getTargetUrl() {
      return this.targetUrl;
    }
  }, {
    key: 'start',
    value: function start() {
      if (!this.targetUrl) {
        throw new Error('targetUrl cant be blank');
      }

      this.server = this.createServer(this.targetUrl);
      this.server.listen(this.port);

      this.logger.log('prxy', 'starting proxy server, entry address: ' + 'http://localhost:' + this.port + ' (pointing at: ' + this.getTargetUrl() + ')');
    }
  }, {
    key: 'stop',
    value: function stop() {
      if (this.server) {
        this.logger.log('prxy', 'stopping proxy server');
        this.server.close();
      }
    }
  }, {
    key: 'restartWithTargetUrl',
    value: function restartWithTargetUrl(targetUrl) {
      this.targetUrl = targetUrl;
      this.stop();
      this.start();
    }

    // private

  }, {
    key: 'createServer',
    value: function createServer(targetUrl) {
      return httpProxy.createProxyServer({ target: targetUrl });
    }
  }]);

  return ProxyServer;
}();

module.exports = ProxyServer;

/***/ }),
/* 3 */
/***/ (function(module, exports) {

module.exports = require("node-discover");

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-disable no-multi-spaces */


var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var NodeDiscover = __webpack_require__(3);
var GitServer = __webpack_require__(1);
var GatewayServer = __webpack_require__(2);
var Logger = __webpack_require__(0);

var NullNet = function () {
  function NullNet() {
    _classCallCheck(this, NullNet);
  }

  _createClass(NullNet, [{
    key: 'stop',
    value: function stop() {
      return Promise.resolve();
    }
  }]);

  return NullNet;
}();

var Starbucket = function () {
  function Starbucket(attrs) {
    var _this = this;

    _classCallCheck(this, Starbucket);

    this.gatewayServerPort = attrs.gatewayServerPort;
    this.gitServerPort = attrs.gitServerPort;
    this.localReposStoragePath = attrs.localReposStoragePath;
    this.logger = attrs.logger || new Logger();

    this.net = new NullNet();
    this.isMaster = false;
    this.gatewayServer = this.configureGatewayServer();
    this.gitServer = this.configureGitServer(function (repoName) {
      _this.net.send('update-available', { repoName: repoName });
    });
  }

  _createClass(Starbucket, [{
    key: 'start',
    value: function start() {
      return Promise.all([this.gitServer.start(), this.configureAndStartDiscoveryService()]);
    }
  }, {
    key: 'stop',
    value: function stop() {
      this.isMaster = false;
      return Promise.all([this.gitServer.stop(), this.stopDiscoveryService()]);
    }
  }, {
    key: 'clearTmp',
    value: function clearTmp() {
      return this.gitServer.clearTmp();
    }
  }, {
    key: 'isMasterNode',
    value: function isMasterNode() {
      return this.isMaster;
    }

    // net events

  }, {
    key: 'onPromoteToMaster',
    value: function onPromoteToMaster() {
      this.logger.log('net', 'promotion to be a MASTER node');

      this.isMaster = true;
      this.net.leave('update-available');
      this.gatewayServer.restartWithTargetUrl('http://localhost:' + this.gitServerPort);
    }
  }, {
    key: 'onNewMasterChosen',
    value: function onNewMasterChosen(netNodeInfo) {
      var _this2 = this;

      this.logger.log('net', 'other node is a MASTER: ' + netNodeInfo.address);

      this.isMaster = false;
      this.gatewayServer.restartWithTargetUrl('http://' + netNodeInfo.address + ':' + netNodeInfo.advertisement.gitServerPort);

      this.net.join('update-available', function (data) {
        _this2.logger.log('net', 'update available for: ' + data.repoName);
        _this2.gitServer.mirrorRepo(_this2.gatewayServer.getTargetUrl(), data.repoName);
      });
    }

    // setup

  }, {
    key: 'configureAndStartDiscoveryService',
    value: function configureAndStartDiscoveryService() {
      var _this3 = this;

      return new Promise(function (resolve) {
        _this3.net = NodeDiscover({ ignoreProcess: false });
        _this3.net.advertise({ gitServerPort: _this3.gitServerPort });

        _this3.net.once('promotion', resolve);
        _this3.net.once('master', resolve);

        _this3.net.on('promotion', function () {
          _this3.onPromoteToMaster();
        });
        _this3.net.on('master', function (netNodeInfo) {
          _this3.onNewMasterChosen(netNodeInfo);
        });
        _this3.net.on('demotion', function () {
          _this3.logger.log('net', 'demoted from being a MASTER');
        });
        _this3.net.on('added', function (netNodeInfo) {
          _this3.logger.log('net', 'new node discovered: ' + netNodeInfo.address);
        });
        _this3.net.on('removed', function (netNodeInfo) {
          _this3.logger.log('net', 'node removed ' + netNodeInfo.address);
        });
      });
    }
  }, {
    key: 'configureGatewayServer',
    value: function configureGatewayServer() {
      return new GatewayServer({
        logger: this.logger,
        port: this.gatewayServerPort
      });
    }
  }, {
    key: 'configureGitServer',
    value: function configureGitServer(gitDataReceivedCallback) {
      return new GitServer({
        logger: this.logger,
        port: this.gitServerPort,
        storagePath: this.localReposStoragePath,
        dataReceivedCallback: gitDataReceivedCallback
      });
    }
  }, {
    key: 'stopDiscoveryService',
    value: function stopDiscoveryService() {
      var _this4 = this;

      return new Promise(function (resolve) {
        _this4.net.stop();
        _this4.net = new NullNet();
        resolve();
      });
    }
  }]);

  return Starbucket;
}();

module.exports = Starbucket;

/***/ }),
/* 5 */
/***/ (function(module, exports) {

module.exports = require("child_process");

/***/ }),
/* 6 */
/***/ (function(module, exports) {

module.exports = require("fs-extra");

/***/ }),
/* 7 */
/***/ (function(module, exports) {

module.exports = require("http");

/***/ }),
/* 8 */
/***/ (function(module, exports) {

module.exports = require("http-proxy");

/***/ }),
/* 9 */
/***/ (function(module, exports) {

module.exports = require("node-git-server");

/***/ })
/******/ ]);
});